%%% Spectra of 13C (Fig 1c of PRL 124, 220501 (2020))
clear
clc

Ix = [0 1; 1 0]/2;
Iy = [0 -1i; 1i 0]/2;
Iz = [1 0;0 -1]/2;

nu_c = -0.158e6;
Azz = -0.152e6;
Azx = 0.1095e6;

H1 = 2*pi*((nu_c-Azz/2)*kron(eye(2),Iz)+Azz*kron(Iz,Iz)+Azx*kron(Iz,Ix)-Azx/2*kron(eye(2),Ix));

% rho0 = [1 0 0 0; 0 0 0 0; 0 0 0 0; 0 0 0 0];
rho0 = [1 0 0 0; 0 0 0 0; 0 0 0 0; 0 0 0 0];
U_ini = kron(expm(-1i*pi/10*Ix),eye(2));
U_Had = kron(eye(2),[1 1;1 -1]/sqrt(2));

t = 20e-9:800e-9:100.20e-6;
dt = t(3)-t(2);
load 22h09s.DAT
p0 = X22h09s(:,2);

sig = 80.02e-6;
f_win = exp(-(t/sig).^2);

p0= p0'.*f_win;

p0f = real(fft(p0,8192)); 
xp0f = (0:length(p0f)-1)/dt/length(p0f)-1600;
p0f = p0f/14.1;
hold on

for k = 1:length(t)

    U2 = expm(-1i*H1*t(k));

    rho1{k} = U_Had*U2*rho0*(U_Had*U2)'; %% ms = 0
    
    p(k) = sum(rho1{k}(1,1));

end
subplot(2,1,1)
plot(t,real(p),'r')
sig = 50e-6;
f_win = exp(-(t/sig).^2);
p = p.*f_win;

pf = real(fft(p,32768)); 
x = (0:length(pf)-1)/dt/length(pf);
hold on
% plot(x,pf/max(pf),'r')


% subplot(2,1,2)
plot(xp0f(1:end/2),p0f(1:end/2),'k','linewidth',2)
hold on 
plot(x(1:end/2),pf(1:end/2)/14.1,'r')
xlabel('Frequency (Hz)')
ylabel('Amplitude')
title('Fig. 2(c)  of PRL 124, 220501 (2020))')
