%%% Spectra of electron (Fig 4a of PRL 124, 220501 (2020))
clear 
clc

%%% subspace 2

Ix = [0 1; 1 0]/2;
Iy = [0 -1i; 1i 0]/2;
Iz = [1 0;0 -1]/2;

nu_c = -0.1614e6;
Azz = -0.152e6;
Azx = 0.1095e6;

H = 2*pi*((nu_c-Azz/2)*kron(eye(2),Iz)+Azz*kron(Iz,Iz)+Azx*kron(Iz,Ix)-Azx/2*kron(eye(2),Ix));

rho0 = [1 0 0 0; 0 0 0 0; 0 0 0 0; 0 0 0 0];
U_cnot = kron([1 0;0 0],eye(2))+kron([0 0;0 1],expm(-1i*pi*Ix));
U_ini = expm(-1i*pi*kron(Ix,eye(2)));


%% without cnot
t = 0:80e-9:40e-6; 
dt = t(3)-t(2);

hold on
load 23h19s.DAT 
p1 = X23h19s(:,2);

load 23h34s.DAT  
p2 = X23h34s(:,2);
p1 = (p1+p2)/2;
p1 = p1*exp(1i*pi/10); 
norm = 15.5;

sig = 40.02e-6;
f_win = exp(-(t/sig).^2);
p1= p1'.*f_win;
p1f = real(fft(p1,8192))/norm; 
xp1f = (0:length(p1f)-1)/dt/length(p1f);
subplot(1,2,1)
plot(xp1f(1:end/2),p1f(1:end/2),'r','linewidth',2)
hold on


load 17h21s.DAT 
p2 = X17h21s(:,2);
load 18h40s.DAT 
p1 = X18h40s(:,2);
p2 = (p1+p2)/2;

sig = 40.02e-6;
f_win = exp(-(t/sig).^2);
pt= p2'.*f_win;


ptf = abs(fft(pt,8192))/norm; 
xptf = (0:length(ptf)-1)/dt/length(ptf);

plot(xptf(1:end/2),ptf(1:end/2)+0.1,'g','linewidth',2)
xlabel('Frequency (Hz)')
ylabel('Amplitude')
title('Fig. 4(a)  of PRL 124, 220501 (2020))')
axis([2.5e6 3.5e6 -2 2])

%% with CNOT
rho0 = U_cnot*rho0*(U_cnot)';

sig = 20e-6;
f_win = exp(-(t/sig).^2);

subplot(1,2,2)

hold on

hold on

load 02h09s.DAT  
p1 = X02h09s(:,2);
load 02h21s.DAT  
p2 = X02h21s(:,2);

p2 = (p1+p2)/2;
p2 = p2*exp(-1i*pi/6);

p2f = real(fft(p2,8192)); 
xp2f = (0:length(p2f)-1)/dt/length(p2f)+30000;

hold on
plot(xp2f(1:end/2),p2f(1:end/2)/norm,'r','linewidth',2)
plot(xptf(1:end/2),ptf(1:end/2)+0.1,'g','linewidth',2)
axis([2.5e6 3.5e6 -2 2])
xlabel('Frequency (Hz)')
ylabel('Amplitude')

