%%% Spectra of 13C (Fig 4b of PRL 124, 220501 (2020))

clear
clc
% figure
Ix = [0 1; 1 0]/2;
Iy = [0 -1i; 1i 0]/2;
Iz = [1 0;0 -1]/2;

nu_c = -0.158e6;
Azz = -0.152e6;
Azx = 0.1095e6;

H1 = 2*pi*((nu_c-Azz/2)*kron(eye(2),Iz)+Azz*kron(Iz,Iz)+Azx*kron(Iz,Ix)-Azx/2*kron(eye(2),Ix));

rho0 = [0.8 0.08 0 0; 0.08 0.2 0 0; 0 0 0 0; 0 0 0 0];
% rho0 = [1 0 0 0; 0 0 0 0; 0 0 0 0; 0 0 0 0];
U_cnot = kron([1 0;0 0],eye(2))+kron([0 0;0 1],expm(-1i*pi*Ix));
U_ini = kron(expm(-1i*pi*Ix),eye(2));
V = kron([1 0;0 0],eye(2))+kron([0 0;0 1],expm(-1i*pi/2*Iy));%rho0 = V*rho0*V';
rho0 = U_ini*rho0*(U_ini)';

% return
%% without CNOT
t = 20e-9:800e-9:200.00e-6;
dt = t(3)-t(2);


for k = 1:length(t)

    U1 = kron(eye(2),expm(-1i*pi/2*Ix));
    U2 = expm(-1i*H1*t(k));
    U3 = kron(eye(2),expm(-1i*pi/2*Ix));
    
    U_pi = kron(expm(-1i*pi*Ix),eye(2));
    rho1{k} = U_pi*U2*rho0*(U_pi*U2)'; %% ms = -1 %% ms = -1

p(k) = rho1{k}(2,2);

end

sig = 80e-6;
f_win = exp(-(t/sig).^2);
p = p.*f_win; 
norm = 14;
subplot(1,2,1)
pf = real(fft(p,32768)); 
x = (0:length(pf)-1)/dt/length(pf);
hold on
plot(x,pf/norm,'r')

xlabel('Frequency (Hz)')
ylabel('Amplitude')
title('Fig. 4(b)  of PRL 124, 220501 (2020))')
axis([0.07e6 0.2e6 -2 2])
%% expt

t = 20e-9:800e-9:100.02e-6;
dt = t(2)-t(1);


% load 22h43s.DAT
% p0 = X22h43s(:,2);
load 20h38s.DAT
p0 = X20h38s(:,2);
p0 = p0*exp(-1i*2.1); %% phase correction

sig = 100.02e-6;
f_win = exp(-(t/sig).^2);
p0= p0'.*f_win;

p0f = real(fft(p0,8192)); 
xp0f = (0:length(p0f)-1)/dt/length(p0f)-1600;
p0f = p0f/7.5-0.02; %normalized

plot(xp0f(1:end/2),p0f(1:end/2),'b','linewidth',2)


%% with CNOT
t = 20e-9:800e-9:200.02e-6;
dt = t(3)-t(2);

rho0 = U_cnot*rho0*(U_cnot)';

for k = 1:length(t)

    U1 = kron(eye(2),expm(-1i*pi/2*Ix));
    U2 = expm(-1i*H1*t(k));
    U3 = kron(eye(2),expm(-1i*pi/2*Ix));
  
    U_pi = kron(expm(-1i*pi*Ix),eye(2));
    rho1{k} = U_pi*U2*rho0*(U_pi*U2)'; %% ms = -1 %% ms = -1

    p(k) = rho1{k}(2,2);

end

sig = 80e-6;
f_win = exp(-(t/sig).^2);
p = p.*f_win; 
subplot(1,2,2)
pf = real(fft(p,32768)); 
x = (0:length(pf)-1)/dt/length(pf);
hold on
% plot(x,pf/max(pf)*0.8,'r')
plot(x,pf/norm*0.8,'r')

t = 20e-9:800e-9:100.02e-6;
dt = t(2)-t(1);
% load 22h23s.DAT
% pe = X22h23s(:,2);
load 00h39s.DAT
pe = X00h39s(:,2);
p0 = pe*exp(-1i*2.1); %% phase correction

sig = 100.02e-6;
f_win = exp(-(t/sig).^2);
p0= p0'.*f_win;

p0f = real(fft(p0,8192)); 
xp0f = (0:length(p0f)-1)/dt/length(p0f)-2000;
% p0f = p0f/max(p0f)-0.02;
p0f = p0f/7.5-0.02;


plot(xp0f(1:end/2),p0f(1:end/2),'b','linewidth',2)
axis([0.07e6 0.2e6 -2 2])