%%% NOOP (Fig 5a of PRL 124, 220501 (2020))

clear
clc

Ix = [0 1; 1 0]/2;
Iy = [0 -1i; 1i 0]/2;
Iz = [1 0;0 -1]/2;

nu_c = -0.158e6;
Azz = -0.152e6;
Azx = 0.1095e6;

rho0 = [1 0 0 0; 0 0 0 0; 0 0 0 0; 0 0 0 0];

U_cnot = kron([1 0;0 0],eye(2))+kron([0 0;0 1],expm(-1i*pi*Ix));

theta_deg = linspace(0,360,50);
theta = zeros(1,length(theta_deg));
p1    = zeros(1,length(theta_deg));
p2    = zeros(1,length(theta_deg));

for j = 1:length(theta_deg)
    theta(j) = pi/180*theta_deg(j);

    U_ini = expm(-1i*theta(j)*kron(Ix,eye(2)));
    U_pi= expm(-1i*pi*kron(Ix,eye(2)));

    rho{j} = U_ini*rho0*(U_ini)';

    p1(j) = real(rho{j}(1,1));
    p2(j) = real(rho{j}(2,2)); 

end
subplot(2,1,1)
plot(theta,1-p1,'r-')
hold on
title('Fig. 5(a)  of PRL 124, 220501 (2020))')

t = 20e-9:80e-9:20e-6;
dt = t(2)-t(1);


theta_exp = pi/180*[45 90 135 180 225 270 315];
%% 45 deg
load 13h36s.DAT
pe = X13h36s(:,2);
% plot(t,pe)
pf = real(fft(pe,32768)); %pf = abs(pf(1:length(pf)/2));
x = (0:length(pf)-1)/dt/length(pf);

x1_45 = sum(pf(x > 2.797e6 & x < 3e6));
x2_45 = sum(pf(x > 3e6 & x < 3.16e6));


%% 90
load 16h44s.DAT
pe = X16h44s(:,2);
% plot(t,pe)
pf = real(fft(pe,32768)); %pf = abs(pf(1:length(pf)/2));
x = (0:length(pf)-1)/dt/length(pf);

x1_90 = sum(pf(x > 2.797e6 & x < 3e6));
x2_90 = sum(pf(x > 3e6 & x < 3.16e6));

%% 135
load 13h59s.DAT
pe = X13h59s(:,2);
% plot(t,pe)
pf = real(fft(pe,32768)); %pf = abs(pf(1:length(pf)/2));
x = (0:length(pf)-1)/dt/length(pf);

x1_135 = sum(pf(x > 2.797e6 & x < 3e6));
x2_135 = sum(pf(x > 3e6 & x < 3.16e6));


%% 180
load 17h04s.DAT
pe = X17h04s(:,2);
% plot(t,pe)
pf = real(fft(pe,32768)); %pf = abs(pf(1:length(pf)/2));
x = (0:length(pf)-1)/dt/length(pf);

x1_180 = sum(pf(x > 2.797e6 & x < 3e6));
x2_180 = sum(pf(x > 3e6 & x < 3.16e6));


%% 225 deg
load 14h19s.DAT
pe = X14h19s(:,2);
% plot(t,pe)
pf = real(fft(pe,32768)); %pf = abs(pf(1:length(pf)/2));
x = (0:length(pf)-1)/dt/length(pf);

x1_225 = sum(pf(x > 2.797e6 & x < 3e6));
x2_225 = sum(pf(x > 3e6 & x < 3.16e6));

%% 270
load 14h40s.DAT
pe = X14h40s(:,2);
% plot(t,pe)
pf = real(fft(pe,32768)); %pf = abs(pf(1:length(pf)/2));
x = (0:length(pf)-1)/dt/length(pf);

x1_270 = sum(pf(x > 2.797e6 & x < 3e6));
x2_270 = sum(pf(x > 3e6 & x < 3.16e6));

%% 315
load 16h24s.DAT
pe = X16h24s(:,2);
% plot(t,pe)
pf = real(fft(pe,32768)); %pf = abs(pf(1:length(pf)/2));
x = (0:length(pf)-1)/dt/length(pf);

x1_315 = sum(pf(x > 2.797e6 & x < 3e6));
x2_315 = sum(pf(x > 3e6 & x < 3.16e6));

x2e = abs([x2_45 x2_90 x2_135 x2_180 x2_225 x2_270 x2_315]);x2e =  x2e/max(x2e);

hold on
plot(theta_exp, 1-x2e,'r*')


