%%% CNOT (Fig 5a of PRL 124, 220501 (2020))

clear
clc

Ix = [0 1; 1 0]/2;
Iy = [0 -1i; 1i 0]/2;
Iz = [1 0;0 -1]/2;

nu_c = -0.158e6;
Azz = -0.152e6;
Azx = 0.1095e6;

% rho0 = [0.8 0.02 0 0; 0.02 0.2 0 0; 0 0 0 0; 0 0 0 0];
rho0 = [1 0 0 0; 0 0 0 0; 0 0 0 0; 0 0 0 0];

U_cnot = kron([1 0;0 0],eye(2))+kron([0 0;0 1],expm(-1i*pi*Ix));

theta_deg = linspace(0,360,50);
theta = zeros(1,length(theta_deg));
p1    = zeros(1,length(theta_deg));
p2    = zeros(1,length(theta_deg));

% return
for j = 1:length(theta_deg)
    theta(j) = pi/180*theta_deg(j);

    U_ini = expm(-1i*theta(j)*kron(Ix,eye(2)));
    U_pi= expm(-1i*pi*kron(Ix,eye(2)));

    rho{j} = U_cnot*U_ini*rho0*(U_cnot*U_ini)';

    p1(j) = real(rho{j}(1,1));
    p2(j) = real(rho{j}(2,2)); 

end
% subplot(1,6,4)
subplot(2,1,2)
plot(theta,(1-p1)*0.9,'r-')
hold on

% return

t = 0:50e-9:20e-6;
dt = t(2)-t(1);


theta_exp = pi/180*[5 25 45 65 90 110 130 150 180 200 220 240 260 280 300 320];
%% 5 deg
load 19h33s.DAT
pe = X19h33s(:,2);
% plot(t,pe)
pf = real(fft(pe,32768)); %pf = abs(pf(1:length(pf)/2));
x = (0:length(pf)-1)/dt/length(pf);

x1_5 = sum(pf(x > 2.797e6 & x < 3e6));
x2_5 = sum(pf(x > 3e6 & x < 3.16e6));


%% 25
load 20h19s.DAT
pe = X20h19s(:,2);
% plot(t,pe)
pf = real(fft(pe,32768)); %pf = abs(pf(1:length(pf)/2));
x = (0:length(pf)-1)/dt/length(pf);

x1_25 = sum(pf(x > 2.797e6 & x < 3e6));
x2_25 = sum(pf(x > 3e6 & x < 3.16e6));

%% 45
load 21h09s.DAT
pe = X21h09s(:,2);
% plot(t,pe)
pf = real(fft(pe,32768)); %pf = abs(pf(1:length(pf)/2));
x = (0:length(pf)-1)/dt/length(pf);

x1_45 = sum(pf(x > 2.797e6 & x < 3e6));
x2_45 = sum(pf(x > 3e6 & x < 3.16e6));


%% 65
load 21h58s.DAT
pe = X21h58s(:,2);
% plot(t,pe)
pf = real(fft(pe,32768)); %pf = abs(pf(1:length(pf)/2));
x = (0:length(pf)-1)/dt/length(pf);

x1_65 = sum(pf(x > 2.797e6 & x < 3e6));
x2_65 = sum(pf(x > 3e6 & x < 3.16e6));


%% 90 deg
load 23h44s.DAT
pe = X23h44s(:,2);
% plot(t,pe)
pf = real(fft(pe,32768)); %pf = abs(pf(1:length(pf)/2));
x = (0:length(pf)-1)/dt/length(pf);

x1_90 = sum(pf(x > 2.797e6 & x < 3e6));
x2_90 = sum(pf(x > 3e6 & x < 3.16e6));

%% 110
load 00h57s.DAT
pe = X00h57s(:,2);
% plot(t,pe)
pf = real(fft(pe,32768)); %pf = abs(pf(1:length(pf)/2));
x = (0:length(pf)-1)/dt/length(pf);

x1_110 = sum(pf(x > 2.797e6 & x < 3e6));
x2_110 = sum(pf(x > 3e6 & x < 3.16e6));

%% 130
load 01h43s.DAT
pe = X01h43s(:,2);
% plot(t,pe)
pf = real(fft(pe,32768)); %pf = abs(pf(1:length(pf)/2));
x = (0:length(pf)-1)/dt/length(pf);

x1_130 = sum(pf(x > 2.797e6 & x < 3e6));
x2_130 = sum(pf(x > 3e6 & x < 3.16e6));

%% 150
load 02h42s.DAT
pe = X02h42s(:,2);
% plot(t,pe)
pf = real(fft(pe,32768)); %pf = abs(pf(1:length(pf)/2));
x = (0:length(pf)-1)/dt/length(pf);

x1_150 = sum(pf(x > 2.797e6 & x < 3e6));
x2_150 = sum(pf(x > 3e6 & x < 3.16e6));

%% 180
load 03h28s.DAT
pe = X03h28s(:,2);
% plot(t,pe)
pf = real(fft(pe,32768)); %pf = abs(pf(1:length(pf)/2));
x = (0:length(pf)-1)/dt/length(pf);

x1_180 = sum(pf(x > 2.797e6 & x < 3e6));
x2_180 = sum(pf(x > 3e6 & x < 3.16e6));

%% 200
load 04h16s.DAT
pe = X04h16s(:,2);
% plot(t,pe)
pf = real(fft(pe,32768)); %pf = abs(pf(1:length(pf)/2));
x = (0:length(pf)-1)/dt/length(pf);

x1_200 = sum(pf(x > 2.797e6 & x < 3e6));
x2_200 = sum(pf(x > 3e6 & x < 3.16e6));

%% 220
load 19h52s.DAT
pe = X19h52s(:,2);
% plot(t,pe)
pf = real(fft(pe,32768)); %pf = abs(pf(1:length(pf)/2));
x = (0:length(pf)-1)/dt/length(pf);

x1_220 = sum(pf(x > 2.797e6 & x < 3e6));
x2_220 = sum(pf(x > 3e6 & x < 3.16e6));

%% 240
load 19h06s.DAT
pe = X19h06s(:,2);
% plot(t,pe)
pf = real(fft(pe,32768)); %pf = abs(pf(1:length(pf)/2));
x = (0:length(pf)-1)/dt/length(pf);

x1_240 = sum(pf(x > 2.797e6 & x < 3e6));
x2_240 = sum(pf(x > 3e6 & x < 3.16e6));

%% 260
load 22h40s.DAT
pe = X22h40s(:,2);
% plot(t,pe)
pf = real(fft(pe,32768)); %pf = abs(pf(1:length(pf)/2));
x = (0:length(pf)-1)/dt/length(pf);

x1_260 = sum(pf(x > 2.797e6 & x < 3e6));
x2_260 = sum(pf(x > 3e6 & x < 3.16e6));

%% 280
load 23h28s.DAT
pe = X23h28s(:,2);
% plot(t,pe)
pf = real(fft(pe,32768)); %pf = abs(pf(1:length(pf)/2));
x = (0:length(pf)-1)/dt/length(pf);

x1_280 = sum(pf(x > 2.797e6 & x < 3e6));
x2_280 = sum(pf(x > 3e6 & x < 3.16e6));

%% 300
% load 23h37s.DAT
% pe = X23h37s(:,2);
dt = 80e-9;
load 18h23s.DAT
pe = X18h23s(:,2);
% plot(t,pe)
pf = real(fft(pe,32768)); %pf = abs(pf(1:length(pf)/2));
x = (0:length(pf)-1)/dt/length(pf);

x1_300 = sum(pf(x > 2.797e6 & x < 3e6));
x2_300 = sum(pf(x > 3e6 & x < 3.16e6));

%% 320
% load 01h43s.DAT
% pe = X01h43s(:,2);
load 17h55s.DAT
pe = X17h55s(:,2);
% plot(t,pe)
pf = real(fft(pe,32768)); %pf = abs(pf(1:length(pf)/2));
x = (0:length(pf)-1)/dt/length(pf);

x1_320 = sum(pf(x > 2.797e6 & x < 3e6));
x2_320 = sum(pf(x > 3e6 & x < 3.16e6));

%% 340
dt = 50e-9;
load 04h03s.DAT
pe = X04h03s(:,2);
% plot(t,pe)
pf = real(fft(pe,32768)); %pf = abs(pf(1:length(pf)/2));
x = (0:length(pf)-1)/dt/length(pf);

x1_340 = sum(pf(x > 2.797e6 & x < 3e6));
x2_340 = sum(pf(x > 3e6 & x < 3.16e6));
x2e = abs([x2_5 x2_25 x2_45 x2_65 x2_90 x2_110 x2_130 x2_150 x2_180 x2_200 x2_220 x2_240 x2_260 x2_280 x2_300 x2_320]);x2e =  (1-x2e/max(x2e))*0.9;

hold on
plot(theta_exp, x2e,'r*')


