%%% CNOT (Fig 5bf main text)

clear
clc

Ix = [0 1; 1 0]/2;
Iy = [0 -1i; 1i 0]/2;
Iz = [1 0;0 -1]/2;


nu_c = -0.158e6;
Azz = -0.152e6;
Azx = 0.1095e6;

H1 = 2*pi*((nu_c-Azz/2)*kron(eye(2),Iz)+Azz*kron(Iz,Iz)+Azx*kron(Iz,Ix)-Azx/2*kron(eye(2),Ix));
H2 = 2*pi*((nu_c+Azz/2)*kron(eye(2),Iz)-Azz*kron(Iz,Iz)-Azx*kron(Iz,Ix)+Azx/2*kron(eye(2),Ix));

rho0 = [1 0 0 0; 0 0 0 0; 0 0 0 0; 0 0 0 0];
% rho0 = [0.8 0.08 0 0; 0.08 0.2 0 0; 0 0 0 0; 0 0 0 0];

U_cnot = kron([1 0;0 0],eye(2))+kron([0 0;0 1],expm(-1i*pi*Ix));

theta_deg = linspace(0,360,50);
theta = zeros(1,length(theta_deg));
p1    = zeros(1,length(theta_deg));
p2    = zeros(1,length(theta_deg));
T2 = 20e-6;
t = 0.5e-6;
for j = 1:length(theta_deg)
    theta(j) = pi/180*theta_deg(j);

    U_ini = expm(-1i*theta(j)*kron(Ix,eye(2)));
    U_pi= expm(-1i*pi*kron(Ix,eye(2)));

    rho{j} = U_cnot*U_ini*rho0*(U_cnot*U_ini)';

    p1(j) = real(rho{j}(1,1));
    p2(j) = real(rho{j}(2,2));   

end
subplot(2,1,2)
plot(theta,(1-p1)*0.7,'r')
hold on


t = 0:50e-9:20.02e-6;
dt = t(2)-t(1);

theta_exp = pi/180*[ 40 60 80 100 120 140 160 180 200 220 240 260 280 300 320 340 ];




%% 20
% load 16h46s.DAT
% pe = X16h46s(:,2);
load 23h01s.DAT
pe = X23h01s(:,2);
% plot(t,pe)
pf = abs(fft(pe,32768)); %pf = abs(pf(1:length(pf)/2));
x = (0:length(pf)-1)/dt/length(pf);

x1_20 = sum(pf(x > 2.797e6 & x < 3e6));
x2_20 = sum(pf(x > 3e6 & x < 3.16e6));

%% 40
load 17h30s.DAT
pe = X17h30s(:,2);
% plot(t,pe)
pf = real(fft(pe,32768)); %pf = abs(pf(1:length(pf)/2));
x = (0:length(pf)-1)/dt/length(pf);

x1_40 = sum(pf(x > 2.797e6 & x < 3e6));
x2_40 = sum(pf(x > 3e6 & x < 3.16e6));


%% 60
load 18h14s.DAT
pe = X18h14s(:,2);
% plot(t,pe)
pf = real(fft(pe,32768)); %pf = abs(pf(1:length(pf)/2));
x = (0:length(pf)-1)/dt/length(pf);

x1_60 = sum(pf(x > 2.797e6 & x < 3e6));
x2_60 = sum(pf(x > 3e6 & x < 3.16e6));


%% 80 deg
load 20h48s.DAT
pe = X20h48s(:,2);
% plot(t,pe)
pf = real(fft(pe,32768)); %pf = abs(pf(1:length(pf)/2));
x = (0:length(pf)-1)/dt/length(pf);

x1_80 = sum(pf(x > 2.797e6 & x < 3e6));
x2_80 = sum(pf(x > 3e6 & x < 3.16e6));

%% 100
load 21h36s.DAT
pe = X21h36s(:,2);
% plot(t,pe)
pf = real(fft(pe,32768)); %pf = abs(pf(1:length(pf)/2));
x = (0:length(pf)-1)/dt/length(pf);

x1_100 = sum(pf(x > 2.797e6 & x < 3e6));
x2_100 = sum(pf(x > 3e6 & x < 3.16e6));

%% 120
load 22h20s.DAT
pe = X22h20s(:,2);
% plot(t,pe)
pf = real(fft(pe,32768)); %pf = abs(pf(1:length(pf)/2));
x = (0:length(pf)-1)/dt/length(pf);

x1_120 = sum(pf(x > 2.75e6 & x < 3e6));
x2_120 = sum(pf(x > 3e6 & x < 3.16e6));

%% 140
% load 23h09s.DAT
% pe = X23h09s(:,2);
load 22h16s.DAT
pe = X22h16s(:,2);
% plot(t,pe)
pf = real(fft(pe,32768)); %pf = abs(pf(1:length(pf)/2));
x = (0:length(pf)-1)/dt/length(pf);

x1_140 = sum(pf(x > 2.797e6 & x < 3e6));
x2_140 = sum(pf(x > 3e6 & x < 3.16e6));

%% 160
load 00h27s.DAT
pe = X00h27s(:,2);
% plot(t,pe)
pf = real(fft(pe,32768)); %pf = abs(pf(1:length(pf)/2));
x = (0:length(pf)-1)/dt/length(pf);

x1_160 = sum(pf(x > 2.797e6 & x < 3e6));
x2_160 = sum(pf(x > 3e6 & x < 3.16e6));

%% 180
load 16h01s.DAT
pe = X16h01s(:,2);
% plot(t,pe)
pf = real(fft(pe,32768)); %pf = abs(pf(1:length(pf)/2));
x = (0:length(pf)-1)/dt/length(pf);

x1_180 = sum(pf(x > 2.797e6 & x < 3e6));
x2_180 = sum(pf(x > 3e6 & x < 3.16e6));

%% 200
load 01h11s.DAT
pe = X01h11s(:,2);
% plot(t,pe)
pf = real(fft(pe,32768)); %pf = abs(pf(1:length(pf)/2));
x = (0:length(pf)-1)/dt/length(pf);

x1_200 = sum(pf(x > 2.797e6 & x < 3e6));
x2_200 = sum(pf(x > 3e6 & x < 3.16e6));

%% 220
load 02h05s.DAT
pe = X02h05s(:,2);
% plot(t,pe)
pf = real(fft(pe,32768)); %pf = abs(pf(1:length(pf)/2));
x = (0:length(pf)-1)/dt/length(pf);

x1_220 = sum(pf(x > 2.797e6 & x < 3e6));
x2_220 = sum(pf(x > 3e6 & x < 3.16e6));

%% 240
load 20h49s.DAT
pe = X20h49s(:,2);
% plot(t,pe)
pf = real(fft(pe,32768)); %pf = abs(pf(1:length(pf)/2));
x = (0:length(pf)-1)/dt/length(pf);

x1_240 = sum(pf(x > 2.797e6 & x < 3e6));
x2_240 = sum(pf(x > 3e6 & x < 3.16e6));


%% 260
load 05h17s.DAT
pe = X05h17s(:,2);
% plot(t,pe)
pf = real(fft(pe,32768)); %pf = abs(pf(1:length(pf)/2));
x = (0:length(pf)-1)/dt/length(pf);

x1_260 = sum(pf(x > 2.797e6 & x < 3e6));
x2_260 = sum(pf(x > 3e6 & x < 3.16e6));


%% 280
load 06h20s.DAT
pe = X06h20s(:,2);
% plot(t,pe)
pf = real(fft(pe,32768)); %pf = abs(pf(1:length(pf)/2));
x = (0:length(pf)-1)/dt/length(pf);

x1_280 = sum(pf(x > 2.797e6 & x < 3e6));
x2_280 = sum(pf(x > 3e6 & x < 3.16e6));

%% 300
load 12h39s.DAT
pe = X12h39s(:,2);
% plot(t,pe)
pf = real(fft(pe,32768)); %pf = abs(pf(1:length(pf)/2));
x = (0:length(pf)-1)/dt/length(pf);

x1_300 = sum(pf(x > 2.797e6 & x < 3e6));
x2_300 = sum(pf(x > 3e6 & x < 3.16e6));

%% 320
load 11h53s.DAT
pe = X11h53s(:,2);
% plot(t,pe)
pf = real(fft(pe,32768)); %pf = abs(pf(1:length(pf)/2));
x = (0:length(pf)-1)/dt/length(pf);

x1_320 = sum(pf(x > 2.797e6 & x < 3e6));
x2_320 = sum(pf(x > 3e6 & x < 3.16e6));

%% 340
load 11h04s.DAT
pe = X11h04s(:,2);
% plot(t,pe)
pf = real(fft(pe,32768)); %pf = abs(pf(1:length(pf)/2));
x = (0:length(pf)-1)/dt/length(pf);

x1_340 = sum(pf(x > 2.797e6 & x < 3e6));
x2_340 = sum(pf(x > 3e6 & x < 3.16e6));

% 

x1e = abs([  x1_40 x1_60 x1_80 x1_100 x1_120 x1_140 x1_160 x1_180 x1_200 x1_220 x1_240 x1_260 x1_280 x1_300 x1_320 x1_340]);x1e = x1e/max(x1e)*0.7;
% % subplot(2,1,2)
plot(theta_exp, x1e,'bd')
hold on
% plot(theta_exp, x2e,'r*-')


